package ch.epfl.tpp.sol;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class JassGameUse {
    public static <E extends Comparable<E>> Iterator<E> sortedIterator(Iterator<? extends E> baseIterator) {
        List<E> iteratorElements = new ArrayList<>();
        while (baseIterator.hasNext())
            iteratorElements.add(baseIterator.next());
        Collections.sort(iteratorElements);
        // Return an iterator over an unmodifiable list so that its remove method throws OperationNotSupportedException.
        // (Otherwise remove would work but not do what the user expects!)
        return Collections.unmodifiableList(iteratorElements).iterator();
    }

    public static void main(String[] args) {
        List<Card> deck = JassGame.buildDeck();
        JassGame.shuffleDeck(deck);
        List<List<Card>> stacks = JassGame.dealDeck(deck, 4);
        int j = 1;
        for (List<Card> stack: stacks) {
            int handValue = 0;
            for (Card c: stack)
                handValue += JassGame.cardPoints(c, Card.Suit.SPADE);
            System.out.println("Main du joueur n°"+ (j++) +" (vaut un total de "+ handValue +" points).");
            Iterator<Card> stackIt = sortedIterator(stack.iterator());
            while (stackIt.hasNext())
                System.out.println("  "+ stackIt.next().frenchName());
        }
    }

}
